/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package serialComms;

import filter.Main;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import util.Serial;

/**
 *
 * @author mm
 */
public class Comms {

    Serial sport;

    public Comms() {
        sport = new Serial();
    }

    public boolean initialize() {

        // Set up K2 in extended command mode.
        sport.serialWrite("K22;", 100); // Use extended command mode.
        sport.serialWrite("K2;", 100); // Verify mode.
        byte[] resp = new byte[32];
        sport.serialRead(resp);
        String r = new String(resp);
        return r.indexOf("K22;") != -1;

        // Verify that a KDSP2 is present.
    }

    public boolean isKdsp2Installled() {
        boolean installed = false;

        return installed;
    }

    public String kdsp2Version() {
        DSdecoder dec = new DSdecoder();
        // Send DISPLAY, RCL, RCL, RCL, RCL, STORE, then capture display.
        sport.serialWrite("SW02;", 100); // DISPLAY
        boolean inGainMode = false;
        for (int i = 0; i < 6; i++) {
            sport.serialWrite("SW17;", 100); // RCL
            String d = dec.getDisplay(sport, true);
            System.out.println("d: '" + d + "'");
            if (d.length() >= 4 && d.charAt(3) == 'G') {
                inGainMode = true;
                break;
            }
        }
        sport.serialWrite("SW19;"); // STORE
        sleep(1000);
        String dsp = dec.getDisplay(sport, true);
        System.out.println("dsp: '" + "'");
        sleep(2000);
        String ctl = dec.getDisplay(sport, true);
        System.out.println("ctl: '" + ctl + "'");
        sleep(1000);
        sport.serialWrite("SW02;"); // DISPLAY
        return dsp + " " + ctl;
    }

    public void sleep(int msec) {
        try {
            Thread.sleep(msec);
        } catch (InterruptedException e) {
        }
    }

    public JPopupMenu serialPopupChoices(final Main main) {
        String serialPorts[] = sport.getSerialPortNames();
        JMenuItem menuItem;
        JPopupMenu popup = new JPopupMenu();
        JLabel name = new JLabel("Choose K2 serial port");
        popup.add(name);
        popup.addSeparator();
        for (int i = 0; i < serialPorts.length; i++) {
            menuItem = new JMenuItem(serialPorts[i]);
            menuItem.addMouseListener(new MouseAdapter() {

                @Override
                public void mousePressed(MouseEvent e) {
                    String port = ((JMenuItem) e.getSource()).getText();
                    sport.setSerialPort("K2", port);
                    if (initialize()) {
                        main.enableModes(true);
                        main.enableDsps(true);
                        kdsp2Version();
                    }
                }
            });
            popup.add(menuItem);
        }
        return popup;
    }
}
