package digital;
import java.awt.Rectangle;

/** Implement the rcl/store button on the front of the virtual W1.  The
 * implementation lets the user either read or write settings from or to the
 * eeprom.
 *
 * Mike Markowski<br>
 * March 2007
 */

public class ButtonRcl extends Button {

	/** Create a rcl/store button specifying internally used button name (not
	 * displayed on-screen) and the geometry in pixels specifying where the
	 * button is on-screen. */
	ButtonRcl(String name, int x0, int y0, int xlen, int ylen) {
		this.name = name;
		this.geometry = new Rectangle(x0, y0, xlen, ylen);
	}

	/** Return W1 command to retrieve settings from eeprom. */
    @Override
	public String getTapFn() { return "U"; }
	/** Return W1 command to save settings to eeprom. */
    @Override
	public String getHoldFn() { return "W"; }
}